/*
** Copyright R-U-ON, 2006
** www.r-u-on.com
*/

#include <string.h>

static char cb64[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
static unsigned char db64[] =
 {62,230,230,230,63,52,53,54,55,56,57,58,59,60,61,230,230,230,230,230,230,230,0,1,
  2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,230,230,230,230,
  230,230,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,
  50,51};

static void encodeblock( unsigned char out[4], unsigned char in[3], int len )
{
    out[0] = cb64[ in[0] >> 2 ];
    out[1] = cb64[ ((in[0] & 0x03) << 4) | ((in[1] & 0xf0) >> 4) ];
    out[2] = (unsigned char) (len > 1 ? cb64[ ((in[1] & 0x0f) << 2) | ((in[2] & 0xc0) >> 6) ] : '=');
    out[3] = (unsigned char) (len > 2 ? cb64[ in[2] & 0x3f ] : '=');
}

static void decodeblock( unsigned char out[3], unsigned char in[4] )
{   
    out[0] = (unsigned char ) (in[0] << 2 | in[1] >> 4);
    out[1] = (unsigned char ) (in[1] << 4 | in[2] >> 2);
    out[2] = (unsigned char ) (((in[2] << 6) & 0xc0) | in[3]);
}


int iao_base64encode(char *dest, void *src, int len) 
{
	int destlen = 0;
	int i;
	for (i=0;i<len;i+=3)
	{
		encodeblock((unsigned char *)dest+destlen, (unsigned char *)src+i, len-i>=3?3:len-i);
		destlen+=4;
		if (destlen%72==0) 
		{
			dest[destlen++]='\n';
		}
	}
	dest[destlen]=0;
	return destlen;
}

int iao_base64decode(void *dest, char *src)
{
	int len = (int) strlen(src);
	int destlen = 0;
	unsigned char block[4];
	int blocklen = 0;
	int i;

	for (i=0;i<len;i++)
	{
		if (src[i] >= 43 && src[i] <=122 && src[i]!='=')
		{
			block[blocklen++] = db64[src[i]-43];
		}
		if (blocklen==4)
		{
			decodeblock( (unsigned char *) dest+destlen, block);
			destlen+=3;
			blocklen=0;
		}
	}
	if (blocklen)
	{
		decodeblock( (unsigned char *) dest+destlen, block);
		destlen+=(blocklen-1);
	}

	return destlen;
}

